import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.event.ComponentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.util.ArrayList;

import javax.swing.JPanel;


public class SPNewMultiPanel extends JPanel implements MouseListener,MouseMotionListener, ComponentListener{
	//
	int puzzleWidth;
	int puzzleHeight;
	int blockWidth;
	int blockHeight;
	boolean diagonal;
	//zuUnit
	ArrayList<Point> posUnit=new ArrayList<Point>();
	int nowX;
	int nowY;
	//`p
	int baseX;
	int baseY;
	int cell;
	//-------------------------------------------------------------
	//
	//-------------------------------------------------------------
	public SPNewMultiPanel() {
		//
		formatField(9,9,3,3,false);
		//
		addMouseListener(this);
		addMouseMotionListener(this);
		addComponentListener(this);
	}
	public void formatField(int pW,int pH,int bW,int bH,boolean dg){
		puzzleWidth=pW;
		puzzleHeight=pH;
		blockWidth=bW;
		blockHeight=bH;
		diagonal=dg;
		//
		posUnit.clear();
		nowX=nowY=-1;
		//
		setPaintBasePoint();
	}
	//-------------------------------------------------------------
	//UnitTCY
	//-------------------------------------------------------------
	private int side(){
		return blockWidth*blockHeight;
	}
	//-------------------------------------------------------------
	//`挴_ƃ}XTCYiplTCYύXPƂŌĂ΂j
	//-------------------------------------------------------------
	private void setPaintBasePoint(){
		//
		Dimension d=getSize();
		int w=d.width/puzzleWidth;
		int h=d.height/puzzleHeight;
		if(w>h){
			cell=h;
		}else{
			cell=w;
		}
		baseX=(d.width-cell*puzzleWidth)/2;
		baseY=(d.height-cell*puzzleHeight)/2;
		//ōĕ`悷̂őł͂ȂĂ
		repaint();
	}
	//-------------------------------------------------------------
	//pY쐬OUnitzum߂
	//-------------------------------------------------------------
	public boolean checkField(){
		//UnitzuȂG[
		if(posUnit.size()==0){	return false;	}
		//---g~O---
		//㉺E̋󂫂𒲂ׂ
		int up=puzzleHeight;
		int down=0;
		int left=puzzleWidth;
		int right=0;
		for(int u=0;u<posUnit.size();u++){
			Point pU=posUnit.get(u);
			if(pU.y<up){ up=pU.y;	}
			if(pU.y+side()>down){ down=pU.y+side();	}
			if(pU.x<left){ left=pU.x;	}
			if(pU.x+side()>right){ right=pU.x+side();	}
		}
		//pYTCY󂫂i󂫂ȂΕsρj
		puzzleHeight-=up+(puzzleHeight-down);
		puzzleWidth-=left+(puzzleWidth-right);
		//ƍɋ󂫂Unitʒu񂹂
		if(up!=0 || left!=0){
			for(int u=0;u<posUnit.size();u++){
				posUnit.get(u).translate(-left,-up);
			}
		}
		//
		return true;
	}
	//-------------------------------------------------------------
	//`
	//-------------------------------------------------------------
	public void paintComponent(Graphics g){
		super.paintComponent(g);	//KviꂪȂƔwiFœhԂȂj
		//g
		for(int w=0;w<=puzzleWidth;w++){
			g.drawLine(baseX+w*cell, baseY, baseX+w*cell, baseY+cell*puzzleHeight);
		}
		for(int h=0;h<=puzzleHeight;h++){
			g.drawLine(baseX, baseY+h*cell, baseX+cell*puzzleWidth, baseY+h*cell);
		}
		//zuUnit
		g.setColor(Color.RED);
		for(int u=0;u<posUnit.size();u++){
			Point uP=posUnit.get(u);
			g.drawRect(baseX+(uP.x)*cell, baseY+(uP.y)*cell, side()*cell, side()*cell);
			g.drawRect(baseX+(uP.x)*cell+1, baseY+(uP.y)*cell+1, side()*cell-2, side()*cell-2);
			if(diagonal){
				g.drawLine(baseX+(uP.x)*cell, baseY+(uP.y)*cell, baseX+((uP.x)+side())*cell, baseY+((uP.y)+side())*cell);
				g.drawLine(baseX+((uP.x)+side())*cell, baseY+(uP.y)*cell, baseX+(uP.x)*cell, baseY+((uP.y)+side())*cell);
			}
		}
		//݈ʒu
		if(nowX!=-1){
			g.setColor(Color.BLUE);
			g.drawRect(baseX+nowX*cell, baseY+nowY*cell, side()*cell, side()*cell);
			g.drawRect(baseX+nowX*cell+1, baseY+nowY*cell+1, side()*cell-2, side()*cell-2);
			if(diagonal){
				g.drawLine(baseX+nowX*cell, baseY+nowY*cell, baseX+(nowX+side())*cell, baseY+(nowY+side())*cell);
				g.drawLine(baseX+(nowX+side())*cell, baseY+nowY*cell, baseX+nowX*cell, baseY+(nowY+side())*cell);
			}
		}
	}
	//-------------------------------------------------------------
	//}EXCxg
	//-------------------------------------------------------------
	public void mouseDragged(MouseEvent e) {
		setNowPos(e);	//݈ʒuύX
		repaint();
	}
	public void mouseMoved(MouseEvent e) {
		setNowPos(e);	//݈ʒuύX
		repaint();
	}
	public void mouseClicked(MouseEvent e) {
		//͈͊OȂI
		if(nowX==-1){	return;	}
		//E≺͂ݏoĂȂ
		if(nowX<=puzzleWidth-side() && nowY<=puzzleHeight-side()){
			Point p=new Point(nowX,nowY);
			//wʒuɊɔzuĂ΍폜ďI
			for(int u=0;u<posUnit.size();u++){
				if(posUnit.get(u).equals(p)){
					posUnit.remove(u);
					return;
				}
			}
			//܂zuȂzu
			posUnit.add(p);
		}
		//
		repaint();
	}
	public void mouseEntered(MouseEvent arg0) {
	}
	public void mouseExited(MouseEvent arg0) {
		nowX=nowY=-1;	//͈͊O
		repaint();
	}
	public void mousePressed(MouseEvent arg0) {
	}
	public void mouseReleased(MouseEvent arg0) {
	}
	//݈ʒu
	private void setNowPos(MouseEvent e){
		//΍W
		int x=e.getX()-baseX;
		int y=e.getY()-baseY;
		//͈͓
		if(x>0 && x<cell*puzzleWidth && y>0 && y<cell*puzzleHeight){
			//}X߂
			nowX=x/cell;
			nowY=y/cell;
		}else{	//͈͊O
			nowX=nowY=-1;
		}
	}
	//-------------------------------------------------------------
	//R|[lgCxgipl̑傫ύX擾j
	//-------------------------------------------------------------
	public void componentHidden(ComponentEvent arg0) {
	}
	public void componentMoved(ComponentEvent arg0) {
	}
	public void componentResized(ComponentEvent e) {
		setPaintBasePoint();	//pl̃TCYςΕ`挴_Đݒ
	}
	public void componentShown(ComponentEvent arg0) {
	}
}
